package uk.ac.ucl.cs.slangta.editor.actions;

import javax.jmi.reflect.RefObject;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import uk.ac.ucl.cs.emofocl.plugin.xmieditor.tree.DAGNode;
import uk.ac.ucl.cs.emofocl.plugin.xmieditor.tree.JMITreeViewer;
import uk.ac.ucl.cs.slangta.jmi.slang.es.InputThroughputScheduledSlidingPenaltyClause;
import uk.ac.ucl.cs.slangta.jmi.types.Duration;



public class GenerateTAAction 
		extends Action 
		implements ISelectionChangedListener {

	
	private final JMITreeViewer PARENT;
	private GenerateTAWizard wiz;
	
	
	public GenerateTAAction(JMITreeViewer parent) {
		PARENT = parent;
		PARENT.addSelectionChangedListener(this);
		selectionChanged(null);
	}
	
	public String getText() {

		return "Generate checkers";
	}
	
	public String getToolTipText() {
		
		return "Generate Timed Automata for on-line monitoring using AXIS handlers"; 
	}
	
	public void run() {
		
		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();

		DAGNode node = (DAGNode)selection.getFirstElement();
		InputThroughputScheduledSlidingPenaltyClause clause = (InputThroughputScheduledSlidingPenaltyClause)node.object;
		double durms = 0;
		if ( clause.getWindow() != null ) {
			Duration duration = (Duration) clause.getWindow();
			durms = duration.inMs();
		}
			
		
		int concur = 0;
		
		concur = clause.getConcurrency();
		
		
		System.out.println("Hello World!");
		System.out.println("The duration is: "+durms);
		System.out.println("The concurrency is: "+concur);
		
		Shell parentShell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
	
		
		wiz = new GenerateTAWizard();
		wiz.init(concur,durms);

		WizardDialog dialog = new WizardDialog(parentShell,wiz);
		int n = dialog.open();
		
		
		

//		DirectoryDialog dialog = new DirectoryDialog(shell);
//		String pathString = dialog.open();
//		if (pathString == null)
//			return;
//		Path path = new Path(pathString);

//		System.out.println("Opening " + pathString);
//		File file = path.toFile();
//		if(!file.exists()) {
//
//			System.out.println("File does not exist");
//			return;
//		}
	}	
	
	public void selectionChanged(SelectionChangedEvent event) {

		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();
		if(selection.isEmpty()) this.setEnabled(false);
		else {
				
			Object node = ((DAGNode)selection.getFirstElement()).object;
			if(node instanceof RefObject) {
				RefObject refObject =  (RefObject) node;
				System.out.println(refObject.getClass().getName());
				if ( refObject.getClass().getName() == "uk.ac.ucl.cs.slangta.jmi.impl.slang.es.InputThroughputScheduledSlidingPenaltyClause_Impl")
				this.setEnabled(true);
			}
			else this.setEnabled(false);
		}
	}
	
}

/*	
	public void run() {

		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();
		Object node = ((DAGNode)selection.getFirstElement()).object;
		RefObject object = null;		
		if(node instanceof RefClass) {

			RefClass proxy = (RefClass)node;
			object = proxy.refCreateInstance(null);
		}	
		else if(node instanceof PropertyPointer) {

			PropertyPointer property = (PropertyPointer)node; 			
			MOFClass metaElement = (MOFClass)property.FEATURE.getType();
			RefClass proxy = EMOFOCLUtilities.getClassProxyFromMetaElement(
					property.REF_OBJECT.refOutermostPackage(), metaElement);
			object = proxy.refCreateInstance(null);
			if(property.FEATURE.getUpper() == 1)
				property.REF_OBJECT.refSetValue(property.FEATURE, object);
			else ((Collection)property.REF_OBJECT.refGetValue(
					property.FEATURE)).add(object);			        
		}
	}

	public void selectionChanged(SelectionChangedEvent event) {

		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();
		
		Object node = ((DAGNode)selection.getFirstElement()).object;
		if(selection.isEmpty()) this.setEnabled(false);
		else {
			if(node instanceof RefObject)
				this.setEnabled(true);
			else this.setEnabled(false);
		}

	}
}
		

 
		if(selection.isEmpty()) this.setEnabled(false);
		else {

			Object node = ((DAGNode)selection.getFirstElement()).object;
			if(node instanceof RefObject) {

				MOFClass meta = (MOFClass)((RefClass)node).refMetaObject();
				this.setEnabled(!meta.getIsAbstract());
				System.out.println(meta.getName());
			}

			else if(node instanceof PropertyPointer) {

				Type meta = ((PropertyPointer)node).FEATURE.getType();
				this.setEnabled(meta instanceof MOFClass &&
						!((MOFClass)meta).getIsAbstract());
				System.out.println(meta.getName());

			}
*/		
	